<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\reviews;


use app\common\model\reviews\GoodsReviews;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * GoodsReviews逻辑
 * Class GoodsReviewsLogic
 * @package app\adminapi\logic\reviews
 */
class GoodsReviewsLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author whitef
     * @date 2024/07/09 17:11
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            GoodsReviews::create([
                'goods_id' => $params['goods_id'],
                'goods_category_id' => $params['goods_category_id'],
                'user_id' => $params['user_id'],
                'rating' => $params['rating'],
                'comment' => $params['comment'],
                'review_image' => $params['review_image'],
                'review_status' => $params['review_status'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author whitef
     * @date 2024/07/09 17:11
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            GoodsReviews::where('id', $params['id'])->update([
                'goods_id' => $params['goods_id'],
                'goods_category_id' => $params['goods_category_id'],
                'user_id' => $params['user_id'],
                'rating' => $params['rating'],
                'comment' => $params['comment'],
                'review_image' => empty($params['review_image'])?'':json_encode($params['review_image']),
                'review_status' => $params['review_status'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author whitef
     * @date 2024/07/09 17:11
     */
    public static function delete(array $params): bool
    {
        return GoodsReviews::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author whitef
     * @date 2024/07/09 17:11
     */
    public static function detail($params): array
    {
        return GoodsReviews::findOrEmpty($params['id'])->toArray();
    }
}